import * as __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__ from "react/jsx-runtime";
import * as __WEBPACK_EXTERNAL_MODULE_react__ from "react";
import * as __WEBPACK_EXTERNAL_MODULE_antd__ from "antd";
import "file-saver";
import * as __WEBPACK_EXTERNAL_MODULE_jszip__ from "jszip";
import * as __WEBPACK_EXTERNAL_MODULE__sources_view_index_js__ from "../sources-view/index.js";
import "./index.css";
// import { CodeGenPreview } from "../code-gen-preview/index";
const code_gen_result_rslib_entry_CodeGenResult = /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react__.forwardRef)(function({ result, schema }, ref) {
    const [paneState, setPaneState] = (0, __WEBPACK_EXTERNAL_MODULE_react__.useState)({
        expandedKeys: [
            "sources",
            "preview"
        ]
    });
    const [gravityCode, setGravityCode] = (0, __WEBPACK_EXTERNAL_MODULE_react__.useState)(null);
    const [refresh, setRefresh] = (0, __WEBPACK_EXTERNAL_MODULE_react__.useState)(0);
    (0, __WEBPACK_EXTERNAL_MODULE_react__.useEffect)(()=>{
        console.log("--result, schema", result, schema);
        setGravityCode(convertCodeGenResult(result, schema));
    }, [
        result
    ]);
    const codeZip = async ()=>{
        const zip = new __WEBPACK_EXTERNAL_MODULE_jszip__["default"]();
        Object.values(gravityCode?.modules || {}).forEach((file)=>{
            zip.file(file.fpath.replace(/^\/+/, ""), file.code);
        });
        return await zip.generateAsync({
            type: "blob"
        });
    };
    (0, __WEBPACK_EXTERNAL_MODULE_react__.useImperativeHandle)(ref, ()=>({
            codeZip
        }));
    if (!result) return null;
    console.log("--gravityCode", gravityCode);
    // const items: TabsProps["items"] = [
    //   {
    //     key: "sources",
    //     label: (
    //       <span>
    //         出码生成的源代码{" "}
    //         <a href="javascript:void(0)" onClick={handleDownloadSources}>
    //           导出/下载 zip 包
    //         </a>
    //       </span>
    //     ),
    //     children: gravityCode != null && (
    //       <SourcesView code={gravityCode} onCodeChange={setGravityCode} />
    //     ),
    //   },
    //   {
    //     key: "preview",
    //     label: (
    //       <span>
    //         在线预览{" "}
    //         <a
    //           href="#refresh"
    //           onClick={(e) => {
    //             e.preventDefault();
    //             e.stopPropagation();
    //             setRefresh(Date.now());
    //           }}
    //         >
    //           刷新
    //         </a>
    //       </span>
    //     ),
    //     children: (
    //       <div
    //         className="code-gen-result-gravity-demo"
    //         style={{ height: "100%" }}
    //       >
    //         <CodeGenPreview
    //           code={gravityCode}
    //           height={"100%"}
    //           refresh={refresh}
    //         />
    //       </div>
    //     ),
    //   },
    // ];
    // return <Tabs className="code-gen-tabs" items={items} />;
    if (!gravityCode) return /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)(__WEBPACK_EXTERNAL_MODULE_antd__.Empty, {});
    return /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)("div", {
        className: "code-gen-source-view",
        children: /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)(__WEBPACK_EXTERNAL_MODULE__sources_view_index_js__.SourcesView, {
            code: gravityCode,
            onCodeChange: setGravityCode
        })
    });
});
function convertCodeGenResult(result, schema) {
    const schemaFiles = {
        "/.project-schema.json": {
            fpath: "/.project-schema.json",
            code: `${JSON.stringify(schema, null, 2)}\n`
        }
    };
    if (!result || !Array.isArray(result) || !result.length) return {
        type: "demo",
        modules: schemaFiles
    };
    const code = {
        type: "demo",
        modules: result.reduce((acc, file)=>({
                ...acc,
                [`/${file.pathName}`]: {
                    fpath: `/${file.pathName}`,
                    code: file.content,
                    entry: void 0,
                    packagejson: [
                        "package.json"
                    ].includes(file.pathName) ? 1 : void 0
                }
            }), {})
    };
    let foundEntry = false;
    // 设置入口文件
    [
        "index.js",
        "index.ts",
        "index.tsx",
        "app.js",
        "app.ts",
        "app.tsx"
    ].forEach((fileName)=>{
        if (!foundEntry) {
            const filePath = `/src/${fileName}`;
            if (code.modules[filePath]) {
                foundEntry = true;
                if ("index.js" === fileName) code.modules[filePath].entry = 1;
                else code.modules["/src/index.js"] = {
                    fpath: "/src/index.js",
                    entry: 1,
                    code: `import "./${fileName.replace(/\.\w+$/, "")}"`
                };
            }
        }
    });
    if (!foundEntry) console.warn("Failed to find entry file for demo.");
    // 补充 schema 文件
    // Object.assign(code.modules, schemaFiles);
    return code;
}
export { code_gen_result_rslib_entry_CodeGenResult as CodeGenResult };
