import * as __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__ from "react/jsx-runtime";
import * as __WEBPACK_EXTERNAL_MODULE_react__ from "react";
import * as __WEBPACK_EXTERNAL_MODULE_antd__ from "antd";
import * as __WEBPACK_EXTERNAL_MODULE__code_gen_preview_fixPreviewCode_js__ from "../code-gen-preview/fixPreviewCode.js";
import "./index.css";
// 使用 CodeSandbox 来进行预览
// @see https://codesandbox.io/docs/api#get-request
function CodeSandboxPreview({ code, height }) {
    const parameters = (0, __WEBPACK_EXTERNAL_MODULE_react__.useMemo)(()=>{
        const files = {};
        if (code && code.modules) {
            const fixedCode = (0, __WEBPACK_EXTERNAL_MODULE__code_gen_preview_fixPreviewCode_js__.fixPreviewCode)(code);
            if (fixedCode) Object.values(fixedCode.modules).forEach((file)=>{
                files[file?.fpath?.slice(1)] = {
                    isBinary: false,
                    content: file.code
                };
            });
            // 入口文件需要顺便引入下样式
            files["src/index.js"] = {
                isBinary: false,
                content: `
          // 目前需要单独引入下样式文件
          import "@alifd/next/dist/next.css";
          import "@alifd/pro-layout/dist/AlifdProLayout.css";

          // 引入入口文件
          import './app';
`
            };
        }
        return {
            files,
            template: "create-react-app"
        };
    }, [
        code
    ]);
    const [state, setState] = (0, __WEBPACK_EXTERNAL_MODULE_react__.useState)({
        parameters,
        sandboxId: "",
        isCreating: false,
        hasError: false,
        error: null
    });
    (0, __WEBPACK_EXTERNAL_MODULE_react__.useEffect)(()=>{
        if (state.parameters !== parameters || "retry" === state.sandboxId || !state.sandboxId) {
            let hasCanceled = false;
            setState((prev)=>({
                    ...prev,
                    hasError: false,
                    code,
                    parameters,
                    isCreating: true
                }));
            (async ()=>{
                try {
                    const sandboxId = await createCodeSandbox(parameters);
                    if (!hasCanceled) setState((prev)=>({
                            ...prev,
                            hasError: false,
                            isCreating: false,
                            sandboxId: sandboxId
                        }));
                } catch (error) {
                    if (!hasCanceled) setState((prev)=>({
                            ...prev,
                            hasError: true,
                            error,
                            isCreating: false
                        }));
                }
            })();
            return ()=>{
                hasCanceled = true;
            };
        }
        return ()=>{};
    }, [
        parameters,
        state.sandboxId,
        state.parameters
    ]);
    const handleRetry = ()=>{
        setState((prev)=>({
                ...prev,
                hasError: false,
                sandboxId: "retry"
            }));
    };
    return /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)("div", {
        className: "code-gen-plugin-code-sandbox-preview",
        style: {
            height
        },
        "data-code-sandbox-id": state.sandboxId,
        children: (()=>{
            if (state.hasError) return /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)(__WEBPACK_EXTERNAL_MODULE_antd__.Alert, {
                message: "生成 CodeSandbox 预览应用失败",
                description: /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsxs)(__WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.Fragment, {
                    children: [
                        /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsxs)("p", {
                            children: [
                                "详细错误：",
                                `${state.error || "网络开小差了"}`
                            ]
                        }),
                        /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)("p", {
                            children: /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)(__WEBPACK_EXTERNAL_MODULE_antd__.Button, {
                                onClick: handleRetry,
                                children: "重新尝试下"
                            })
                        })
                    ]
                })
            });
            return state.sandboxId ? /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)("iframe", {
                src: `https://codesandbox.io/embed/${state.sandboxId}?autoresize=1&fontsize=14&hidenavigation=1&theme=dark&view=preview`,
                title: "CodeSandbox Preview",
                allow: "accelerometer; ambient-light-sensor; camera; encrypted-media; geolocation; gyroscope; hid; microphone; midi; payment; usb; vr; xr-spatial-tracking",
                sandbox: "allow-forms allow-modals allow-popups allow-presentation allow-same-origin allow-scripts"
            }) : /*#__PURE__*/ (0, __WEBPACK_EXTERNAL_MODULE_react_jsx_runtime__.jsx)(__WEBPACK_EXTERNAL_MODULE_antd__.Spin, {
                spinning: true,
                tip: "正在生成 CodeSandbox 预览应用..."
            });
        })()
    });
}
async function createCodeSandbox(parameters) {
    if (!Object.entries(parameters?.files || {}).length) return "";
    const res = await fetch("https://codesandbox.io/api/v1/sandboxes/define?json=1", {
        method: "POST",
        headers: {
            "Content-Type": "application/json",
            Accept: "application/json"
        },
        body: JSON.stringify(parameters)
    });
    if (!res.ok) throw new Error(`创建 CodeSandbox 失败，错误码：${res.status} ${res.statusText}`);
    const json = await res.json().catch((err)=>{
        throw new Error(`创建 CodeSandbox 失败，服务异常(${err?.message || err || "未知异常"})`);
    });
    const { sandbox_id } = json || {};
    if (!sandbox_id || "string" != typeof sandbox_id) throw new Error(`创建 CodeSandbox 失败，服务响应异常`);
    return sandbox_id;
}
export { CodeSandboxPreview };
